function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

import debounce from 'lodash/debounce';
import isFunction from 'lodash/isFunction';

var _name = /*#__PURE__*/new WeakMap();

var _selectors = /*#__PURE__*/new WeakMap();

var _elements = /*#__PURE__*/new WeakMap();

var _fixedHeight = /*#__PURE__*/new WeakMap();

var _condition = /*#__PURE__*/new WeakMap();

var _resizeCondition = /*#__PURE__*/new WeakMap();

var _resizeConditionValue = /*#__PURE__*/new WeakMap();

var _totalHeight = /*#__PURE__*/new WeakMap();

var _isValid = /*#__PURE__*/new WeakMap();

export class ScrollOffsetPart {
  constructor({
    name = '',
    selectors = [],
    elements = [],
    fixedHeight = false,
    condition = false,
    resizeCondition = false
  }) {
    _classPrivateFieldInitSpec(this, _name, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _selectors, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _elements, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _fixedHeight, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _condition, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _resizeCondition, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _resizeConditionValue, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _totalHeight, {
      writable: true,
      value: 0
    });

    _classPrivateFieldInitSpec(this, _isValid, {
      writable: true,
      value: false
    });

    _defineProperty(this, "calculate", () => {
      var _classPrivateFieldGet2;

      _classPrivateFieldSet(this, _isValid, !!((_classPrivateFieldGet2 = _classPrivateFieldGet(this, _elements)) !== null && _classPrivateFieldGet2 !== void 0 && _classPrivateFieldGet2.length));

      if (_classPrivateFieldGet(this, _isValid) && _classPrivateFieldGet(this, _condition) && isFunction(_classPrivateFieldGet(this, _condition))) {
        _classPrivateFieldSet(this, _isValid, _classPrivateFieldGet(this, _isValid) && _classPrivateFieldGet(this, _condition).call(this));
      }

      if (_classPrivateFieldGet(this, _isValid) && _classPrivateFieldGet(this, _resizeCondition) && isFunction(_classPrivateFieldGet(this, _resizeCondition))) {
        if (!('resizeConditionValue' in this)) {
          _classPrivateFieldSet(this, _resizeConditionValue, _classPrivateFieldGet(this, _resizeCondition).call(this));
        }

        _classPrivateFieldSet(this, _isValid, _classPrivateFieldGet(this, _isValid) && _classPrivateFieldGet(this, _resizeConditionValue));
      }

      if (!_classPrivateFieldGet(this, _isValid)) {
        _classPrivateFieldSet(this, _totalHeight, 0);
      } else if (_classPrivateFieldGet(this, _fixedHeight)) {
        _classPrivateFieldSet(this, _totalHeight, _classPrivateFieldGet(this, _fixedHeight));
      } else {
        let totalHeight = 0;

        _classPrivateFieldGet(this, _elements).forEach(element => {
          totalHeight += element ? element.clientHeight : 0;
        });

        _classPrivateFieldSet(this, _totalHeight, totalHeight);
      }

      return this;
    });

    _defineProperty(this, "calculateResizeConditions", () => {
      if (_classPrivateFieldGet(this, _resizeCondition) && isFunction(_classPrivateFieldGet(this, _resizeCondition))) {
        const oldValue = _classPrivateFieldGet(this, _resizeConditionValue) || false;

        _classPrivateFieldSet(this, _resizeConditionValue, _classPrivateFieldGet(this, _resizeCondition).call(this));

        return oldValue != _classPrivateFieldGet(this, _resizeConditionValue);
      }

      return false;
    });

    _classPrivateFieldSet(this, _name, name);

    _classPrivateFieldSet(this, _selectors, (selectors || []).filter(Boolean));

    _classPrivateFieldSet(this, _elements, (elements || []).filter(Boolean));

    _classPrivateFieldSet(this, _fixedHeight, fixedHeight);

    _classPrivateFieldSet(this, _condition, condition);

    _classPrivateFieldSet(this, _resizeCondition, resizeCondition);

    _classPrivateFieldGet(this, _selectors).forEach(selector => {
      const newElements = [...document.querySelectorAll(selector)];

      if (newElements.length) {
        _classPrivateFieldSet(this, _elements, [..._classPrivateFieldGet(this, _elements), ...newElements]);
      }
    });

    this.calculate();
  }

  get name() {
    return _classPrivateFieldGet(this, _name);
  }

  get totalHeight() {
    return _classPrivateFieldGet(this, _totalHeight);
  }

  get isValid() {
    return _classPrivateFieldGet(this, _isValid);
  }

  get elements() {
    return _classPrivateFieldGet(this, _elements);
  }

}
/**!
 * ScrollOffset - a class to handle add css variables to the body element,
 * with the value of the "header" parts that are visible
 * so that we can adjust scroll positions etc. based on it
 *
 * Author: Bogdan Barbu
 * Team: Codingheads (codingheads.com)
 */

var _offsetParts = /*#__PURE__*/new WeakMap();

var _variables = /*#__PURE__*/new WeakMap();

var _extraEvents = /*#__PURE__*/new WeakMap();

var _registerForHoudini = /*#__PURE__*/new WeakMap();

var _useResizeObserver = /*#__PURE__*/new WeakMap();

var _registerCssVariables = /*#__PURE__*/new WeakMap();

var _calculateOffset = /*#__PURE__*/new WeakMap();

var _calculateResizeConditions = /*#__PURE__*/new WeakMap();

var _debouncedCalculateOffset = /*#__PURE__*/new WeakMap();

var _debouncedCalculateResizeConditions = /*#__PURE__*/new WeakMap();

var _setupListeners = /*#__PURE__*/new WeakMap();

export class ScrollOffset {
  /**
   * setup the conditions
   */
  constructor({
    offsetParts = [],
    variables = [],
    registerForHoudini = true,
    useResizeObserver = true,
    extraEvents = []
  } = {}) {
    _classPrivateFieldInitSpec(this, _offsetParts, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _variables, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _extraEvents, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _registerForHoudini, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _useResizeObserver, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _registerCssVariables, {
      writable: true,
      value: () => {
        _classPrivateFieldGet(this, _variables).forEach(({
          name
        }) => {
          window.CSS.registerProperty({
            name: `--${name}`,
            syntax: '<length>',
            inherits: true,
            initialValue: '0px'
          });
        });
      }
    });

    _classPrivateFieldInitSpec(this, _calculateOffset, {
      writable: true,
      value: () => {
        // calculate the conditions
        _classPrivateFieldGet(this, _offsetParts).forEach(part => part.calculate()); // determine the css variables


        const cssVariables = _classPrivateFieldGet(this, _variables).map(variable => {
          const value = variable.offsetParts.reduce((acc, part) => {
            if (typeof part == 'string') {
              part = _classPrivateFieldGet(this, _offsetParts).find(partInfo => partInfo.name.localeCompare(part) == 0);
            }

            if (part && part.isValid) {
              acc += part.totalHeight;
            }

            return acc;
          }, 0);
          return _objectSpread(_objectSpread({}, variable), {}, {
            value
          });
        }); // output the variables


        cssVariables.forEach(({
          name,
          value
        }) => {
          document.documentElement.style.setProperty(`--${name}`, `${value}px`);
        });
        document.body.dispatchEvent(new CustomEvent('ScrollOffsetChange', {
          bubbles: true
        }));
      }
    });

    _classPrivateFieldInitSpec(this, _calculateResizeConditions, {
      writable: true,
      value: () => {
        _classPrivateFieldGet(this, _offsetParts).forEach(part => part.calculateResizeConditions());
      }
    });

    _classPrivateFieldInitSpec(this, _debouncedCalculateOffset, {
      writable: true,
      value: debounce(_classPrivateFieldGet(this, _calculateOffset), 32)
    });

    _classPrivateFieldInitSpec(this, _debouncedCalculateResizeConditions, {
      writable: true,
      value: debounce(_classPrivateFieldGet(this, _calculateResizeConditions), 32)
    });

    _classPrivateFieldInitSpec(this, _setupListeners, {
      writable: true,
      value: () => {
        ['resize', 'orientationchange'].forEach(type => {
          window.addEventListener(type, _classPrivateFieldGet(this, _debouncedCalculateResizeConditions));
        });
        ['resize', 'orientationchange', 'scrollDirectionChange', 'stickyIsPinned', 'stickyIsUnpinned', ..._classPrivateFieldGet(this, _extraEvents)].forEach(type => window.addEventListener(type, _classPrivateFieldGet(this, _debouncedCalculateOffset))); // setup resizeObservers for the elements

        if (_classPrivateFieldGet(this, _useResizeObserver)) {
          const resizeObserver = new ResizeObserver(_classPrivateFieldGet(this, _debouncedCalculateOffset));

          _classPrivateFieldGet(this, _offsetParts).forEach(part => part.elements.forEach(element => resizeObserver.observe(element)));
        }
      }
    });

    // parse the variables
    if (Array.isArray(variables)) {
      _classPrivateFieldSet(this, _variables, variables);
    } else {
      _classPrivateFieldSet(this, _variables, Object.entries(variables).map(([key, value]) => {
        return {
          name: key,
          offsetParts: value
        };
      }));
    } // take the offset parts from the variables


    const variableOffsetParts = _classPrivateFieldGet(this, _variables).map(({
      offsetParts
    }) => {
      return offsetParts.filter(part => part instanceof ScrollOffsetPart);
    }).flat(1); // merge with the settings and keep only distinct elements


    offsetParts = [...new Set([...offsetParts, ...variableOffsetParts])]; // parse the offset parts

    _classPrivateFieldSet(this, _offsetParts, offsetParts.map(part => {
      let partObject = null;

      if (!(part instanceof ScrollOffsetPart)) {
        partObject = new ScrollOffsetPart(part);
      } else {
        partObject = part;
      }

      partObject.calculate();
      return partObject;
    }));

    _classPrivateFieldSet(this, _extraEvents, extraEvents || []);

    _classPrivateFieldSet(this, _registerForHoudini, registerForHoudini && 'CSS' in window && 'registerProperty' in window.CSS);

    _classPrivateFieldSet(this, _useResizeObserver, 'ResizeObserver' in window && useResizeObserver);

    if (_classPrivateFieldGet(this, _registerForHoudini)) {
      _classPrivateFieldGet(this, _registerCssVariables).call(this);
    }

    _classPrivateFieldGet(this, _setupListeners).call(this);

    _classPrivateFieldGet(this, _calculateOffset).call(this);
  }
  /**
   * register the css variables as length in the Houdini CSS API
   */


}
export default ScrollOffset;