function _classPrivateMethodInitSpec(obj, privateSet) { _checkPrivateRedeclaration(obj, privateSet); privateSet.add(obj); }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _intersectionElement = /*#__PURE__*/new WeakMap();

var _observer = /*#__PURE__*/new WeakMap();

var _isBelowTheFold = /*#__PURE__*/new WeakMap();

var _belowTheFoldClass = /*#__PURE__*/new WeakMap();

var _aboveTheFoldClass = /*#__PURE__*/new WeakMap();

var _dispatchEvent = /*#__PURE__*/new WeakSet();

var _setupObserver = /*#__PURE__*/new WeakSet();

/**
 * ScrollPages - a class to add classes to the body,
 * detecting whether we are above the fold or below
 * (the above-the-fold are can also be set as an existing element)
 *
 * Author: Bogdan Barbu
 * Team: Codingheads (codingheads.com)
 */
export class ScrollPages {
  /**
   * start an instance
   */
  constructor({
    intersectionElement = null,
    belowTheFoldClass = 'below-the-fold',
    aboveTheFoldClass = 'above-the-fold'
  } = {}) {
    _classPrivateMethodInitSpec(this, _setupObserver);

    _classPrivateMethodInitSpec(this, _dispatchEvent);

    _classPrivateFieldInitSpec(this, _intersectionElement, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _observer, {
      writable: true,
      value: null
    });

    _classPrivateFieldInitSpec(this, _isBelowTheFold, {
      writable: true,
      value: false
    });

    _classPrivateFieldInitSpec(this, _belowTheFoldClass, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _aboveTheFoldClass, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _intersectionElement, intersectionElement);

    _classPrivateFieldSet(this, _belowTheFoldClass, belowTheFoldClass);

    _classPrivateFieldSet(this, _aboveTheFoldClass, aboveTheFoldClass);

    _classPrivateMethodGet(this, _setupObserver, _setupObserver2).call(this);
  }
  /**
   * dispatch an event on the window
   */


}

function _dispatchEvent2(name) {
  requestAnimationFrame(() => {
    window.dispatchEvent(new CustomEvent(name));
  });
}

function _setupObserver2() {
  const body = document.body; // create the intersection element, if it doesn't exist

  if (!_classPrivateFieldGet(this, _intersectionElement)) {
    let containerPosition = window.getComputedStyle(body).getPropertyValue('position');

    if (!containerPosition || containerPosition == 'static') {
      body.style.position = 'relative';
    }

    _classPrivateFieldSet(this, _intersectionElement, document.createElement('div'));

    _classPrivateFieldGet(this, _intersectionElement).classList.add('second-page-observer');

    _classPrivateFieldGet(this, _intersectionElement).style.cssText = 'pointerEvents: none; visibility: hidden; position: absolute; top: 0; left: 0; right: 0; height: 100vh;';
    body.appendChild(_classPrivateFieldGet(this, _intersectionElement));
  }

  body.classList.add(_classPrivateFieldGet(this, _aboveTheFoldClass));

  _classPrivateFieldSet(this, _observer, new IntersectionObserver(entries => {
    let isFirstPage = true;
    entries.forEach(entry => {
      if (!entry.isIntersecting) {
        isFirstPage = false;
      }
    });

    if (_classPrivateFieldGet(this, _isBelowTheFold) != !isFirstPage) {
      _classPrivateFieldSet(this, _isBelowTheFold, !isFirstPage);

      body.classList[_classPrivateFieldGet(this, _isBelowTheFold) ? 'add' : 'remove'](_classPrivateFieldGet(this, _belowTheFoldClass));
      body.classList[!_classPrivateFieldGet(this, _isBelowTheFold) ? 'add' : 'remove'](_classPrivateFieldGet(this, _aboveTheFoldClass));

      _classPrivateMethodGet(this, _dispatchEvent, _dispatchEvent2).call(this, 'ScrollPageChange');
    }
  }));

  _classPrivateFieldGet(this, _observer).observe(_classPrivateFieldGet(this, _intersectionElement));
}

export default ScrollPages;